package com.devdaily.formlayout.demo;

import java.awt.Font;
import javax.swing.*;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.builder.PanelBuilder;
import com.jgoodies.forms.factories.ButtonBarFactory;
import java.awt.Dimension;

public class EditProjectPanel
{
  private ImageIcon imgEdit = new ImageIcon(com.devdaily.formlayout.demo.EditProjectPanel.class.getResource("EditComp32x32.gif"));
  private JLabel lblImage = new JLabel(imgEdit);

  private JLabel lblHeader = new JLabel();
  private JLabel lblHelpText = new JLabel();
  private JLabel lblProjectName=new JLabel();
  private JLabel lblProjectType=new JLabel();
  private JLabel lblProductionFacility=new JLabel();
  private JLabel lblTestConfig=new JLabel();

  private JTextField txtProjectName=new JTextField(20);
  private JComboBox cboProjectType=new JComboBox();
  private JComboBox cboProductionFacility=new JComboBox();
  private JScrollPane projectScrollPane=new JScrollPane();
  private JTable tblProjects=new JTable();
  private JButton btnSave=new JButton("Save");
  private JButton btnCancel=new JButton("Cancel");

  private JPanel newPanel;

  public JPanel getPanel()
  {
    return this.newPanel;
  }
  public EditProjectPanel()
  {
    try
    {
      jbInit();
      newPanel = buildProjectEditPanel();
    }
    catch(Exception exception)
    {
      // replace this with a logger
      System.err.println("Exception occurred in ProjectEditPanel: " + exception.getMessage());
    }
  }
  private void jbInit()
      throws Exception
  {
    lblHeader.setText("Projects :: Edit Project Detail");
    lblHeader.setFont(new Font("Tahoma", Font.BOLD, 14));
    lblHelpText.setText("Use this form to update your project information.");
    lblProjectName.setText("Project Name:");
    lblProjectType.setText("Project Type:");
    lblProductionFacility.setText("Facility:");
    lblTestConfig.setText("Configuration:");
    txtProjectName.setText("");
    projectScrollPane.getViewport().add(tblProjects);
    tblProjects.setPreferredScrollableViewportSize(new Dimension(300, 70));
  }

  private JPanel buildProjectEditPanel()
  {
    // col: use "pref:grow". had bad side-effects w/ "left:pref:grow".
    // row: had to use "fill" to get the table height to expand as desired.
    FormLayout layout = new FormLayout("30px, 2dlu, pref, 2dlu, pref:grow",
                        "p,3dlu,p,9dlu,p,3dlu,p,3dlu,p,3dlu,p,3dlu,fill:pref:grow,3dlu,p,9dlu,p");
    PanelBuilder builder = new PanelBuilder(layout);
    builder.setDefaultDialogBorder();

    CellConstraints cc = new CellConstraints();

    //row 1
    builder.add(lblImage,               cc.xy(1,1));
    builder.add(lblHeader,              cc.xyw(3,1,3));
    builder.add(lblHelpText,            cc.xyw(3,3,3,"left,top"));

    builder.add(lblProjectName,         cc.xy(3,5));
    builder.add(txtProjectName,         cc.xy(5,5));
    lblProjectName.setLabelFor(txtProjectName);

    builder.add(lblProjectType,         cc.xy(3,7));
    builder.add(cboProjectType,         cc.xy(5,7));
    lblProjectType.setLabelFor(cboProjectType);

    builder.add(lblProductionFacility,  cc.xy(3,9));
    builder.add(cboProductionFacility,  cc.xy(5,9));
    lblProductionFacility.setLabelFor(cboProductionFacility);

    builder.add(lblTestConfig,          cc.xy(3,13,"left, top"));
    builder.add(projectScrollPane,      cc.xy(5,13));

    JPanel pnlSaveCancelButtons = ButtonBarFactory.buildOKCancelBar(btnSave,btnCancel);
    builder.add(pnlSaveCancelButtons,   cc.xy(5,15,"left, center"));

    return builder.getPanel();
  }
}





